//
// choose_dict.js
//

var midmyprefs = Components.classes["@mozilla.org/preferences-service;1"].
    getService(Components.interfaces.nsIPrefBranch);

var mylines      = new Array();
dictionary	 = "default"
ExtraClicked     = false;
const miduuidlen = 37;
midNS            = "http://mid.mozdev.org/dictionaries";
allDictArray     = [];
midmyDictionary  = "";



function mud__dictionaryObj( middictId, middictType, middictChecked,
                         middictRestrictions, middictIcon, midWeigth)
{
    this.middictId      = middictId;
    this.middictType    = middictType;
    this.middictChecked = middictChecked;
    this.middictRestrictions = middictRestrictions;
    this.midWeigth = middictIcon;
    this.midWeigth = midWeigth;
}



function mud__saveToCurrent()
{
    //document.documentElement.acceptDialog();
    mud__saveChanges()
    window.close();
}



function mud__initAll()
{

    if (!window.arguments) {
       document.documentElement.getButton('extra1').collapsed = true;
       document.documentElement.getButton('extra2').collapsed = true;
       document.documentElement.getButton('disclosure').collapsed = true;
    } else {
        if (!window.arguments[0].dictionary ||
            window.arguments[0].dictionary == "" ||
	    window.arguments[0].dictionary == "temporary" ||
            window.arguments[0].dictionary == "new"  ||
            window.arguments[0].dictionary == "default") { 
        	document.documentElement.getButton('extra2').collapsed = true;
        }
       dictionary = window.arguments[0].dictionary; 
    }
    
    //alert (window.arguments[0].dictionary);
    //alert (dictionary);
    
   
    var type, alltypes, i, j, newMenuItem, mytabpanels, newCheck;
    var ful, 	mytabs, mytanpanels, newTab, newTabPanel;

    var midDtypeFirstTab = "";
    var typesarray = new Array;
    alltypes = " ";

    for(i = 0; (a1 = document.getElementsByTagNameNS(midNS, "dict").item(i)); i ++ ) {

       type = a1.getAttribute("type");
      
       // for every type we store the individual dicts in an array
       if (typeof(allDictArray[ type ] ) == "undefined")
	  allDictArray[type] = [];

       var newDictionary = new mud__dictionaryObj(
       a1.getAttribute("dictid"),
	      type ,
	      a1.getAttribute("checked") ,
	      a1.getAttribute("restrictions"),
	      0);


       allDictArray[type][ a1.getAttribute("label")]  = newDictionary;

       if (alltypes.indexOf(type) == -1) {
           alltypes = alltypes + type + " ";
           typesarray.push(type);
       }

   }
    
    typesarray.sort();
    mytabs = document.getElementById("mid_dicttypetabs"); 
    mytabpanels = document.getElementById("mid_dicttypetabpanels"); 

    for (i = 0; i < typesarray.length; i++ ) {
        mytype = typesarray[i];
        first  = mytype.charAt(0).toUpperCase();
        var tabid = "mid_choosdicttab" + first;

        if (! document.getElementById(tabid)) {
            newTab = document.createElement("tab");
            newTab.setAttribute("label", " " + first + " " );
            newTab.setAttribute("id", tabid);
            newTabPanel = document.createElement("listbox");
            newTabPanel.setAttribute("rows", "14");
            //newTabPanel.setAttribute("orient", "vertical");
            newTabPanel.setAttribute("id", "mid_choosedictpanel" + first);
            newTabPanel.setAttribute("style", "-moz-box-align:stretch !important;");	
            newTabPanel.setAttribute("onkeydown", "mud__typeCheckBoxChangeKey(event);");
            newTabPanel.setAttribute("style", "border:0px !important;");
	    mytabs.appendChild(newTab);
            mytabpanels.appendChild(newTabPanel);
	    var newCol = document.createElement("listcol");
	    newCol.setAttribute("style", "margin: 3px !important;");
	    newCol.setAttribute("flex", "1");
	    var newCols = document.createElement("listcols");

	    newCols.appendChild(newCol);
	    newTabPanel.appendChild(newCols);
        } else {
	    newTabPanel = document.getElementById("mid_choosedictpanel" + first);
        };

	        newCheck = document.createElement("listitem");

        newCheck.setAttribute("type", "checkbox");
        newCheck.setAttribute("id", "mid_choosedictcheck" + i);
        newCheck.setAttribute("label", mytype);

        newCheck.setAttribute("crop", "none");
        //newCheck.setAttribute("style", "margin-left: 10px !important;");
        newCheck.setAttribute("onmousedown", "mud__typeCheckBoxChange(event);");
        newTabPanel.appendChild(newCheck);
        newCheck.setAttribute("checked", "false");
        // newCheck.setAttribute("onfocus", "mud__onTypeCheckFocus(this);"); // new

        var j, typ;
        if (window.arguments)  {
           // called from mid
            if (mud__checkThisType(mytype)) {
                newCheck.setAttribute("checked", "true");
            }
        }
        else {
            // from preferences
            if (midmyprefs.getPrefType("extensions.mid.dtype." + mytype) == midmyprefs.PREF_BOOL) {
                newCheck.setAttribute("checked", midmyprefs.getBoolPref("extensions.mid.dtype." + mytype) );
            } else {
                 for (j = 0; 
                     (typ = document.getElementsByTagNameNS(midNS, "default-dict-type").item(j)); 
                     j++) {
                     if (typ.getAttribute("label") == mytype) {
                         newCheck.setAttribute("checked", "true");
                    }
                 } // XML
            }
        }

        if (newCheck.getAttribute( "checked") == "true") {
	    document.getElementById(tabid).setAttribute("style",
                "-moz-appearance: none !important; color:white;background-color: blue!important;");
	    mud__getDictionaries(mytype, "init");
            if ( midDtypeFirstTab == "" ) midDtypeFirstTab = tabid;
        }

    }  // for


    if (midDtypeFirstTab != "") {
        var midmyListbox = document.getElementById("mid_selectdictionaries");
        midmyListbox.scrollToIndex(0);
        midmyListbox.selectItem(midmyListbox.getItemAtIndex(1));
        mytabs.selectedItem = document.getElementById(midDtypeFirstTab);
    }
    else mytabs.selectedIndex = 0;
    
   // sizeToContent();   alert("resized");
   
}

 
 
function mud__saveChanges()
{ 

    var i;
    if (window.arguments) {
        window.arguments[0].result = true;
        dictionary = window.arguments[0].dictionary; 
	//alert(dictionary)    
}

    for(i = 0;
       (dt = document.getElementById("mid_dicttypetabbox").getElementsByTagName("listitem").item(i));i ++ ) {
        if (dt.getAttribute("checked") == "true") {
            if (dictionary == "default")
                midmyprefs.setBoolPref("extensions.mid.dtype." + dt.getAttribute("label"), true);
            mud__savePreferences( dt.getAttribute("label") );
        } else {
        if (dictionary == "default") 
	    midmyprefs.setBoolPref("extensions.mid.dtype." +  dt.getAttribute("label"), false );
        }
    }

    if (dictionary != "default")  {
        window.arguments[0].mylines = mylines;
        window.arguments[0].result = false;
    }
}



function  mud__typeCheckBoxChangeKey(e)             
{

    var key = e.which;
    if (key == 32) {
       mud__typeCheckBoxChange(e);
    }

    return true;
}



function  mud__typeCheckBoxChange(event)             
{
    event.stopPropagation();
    var typeTab = document.getElementById("mid_dicttypetabbox").selectedTab;
    var typePanel = document.getElementById("mid_dicttypetabbox").selectedPanel;
       

    if ('object' == typeof event) { 
       if ( event.type == "mousedown" && (0 != event.button) )
          { event.preventDefault(); return true;} // right click?
    }
    else return;

    var mClickedNode = event.originalTarget;
    if (mClickedNode.nodeName == "listbox") {
        midmypanel = mClickedNode;
        if (mClickedNode.selectedItem) {
            midmylistitem = mClickedNode.currentItem;
        }
        else {
           mClickedNode.selectItem(mClickedNode.getItemAtIndex(0));
           midmylistitem = mClickedNode.currentItem;
        }
    }
    else
    if (mClickedNode.nodeName == "listitem" ) {
       midmypanel = mClickedNode.parentNode;
       midmylistitem = mClickedNode;
    }


    if ((midmypanel.nodeName != "listbox") || 
        (midmylistitem.nodeName != "listitem")) {
	event.preventDefault();
	return;
    }

    vanchecked = false;

    if ( ! (midmylistitem.getAttribute("checked") == "true") ) {    
        mud__getDictionaries( midmylistitem.getAttribute("label") , "click");
        vanchecked = true;
    }
    else
    {
       mud__removeDictionariesFromList(midmylistitem.getAttribute("label"));
       for(i = 0; (dt = midmypanel.getElementsByTagName("listitem").item(i));i++) {
          if (!(dt == midmylistitem)) 
          if (dt.getAttribute("checked") == "true") vanchecked = true;
       }
    }

    if (vanchecked) typeTab.setAttribute("style",
            "-moz-appearance: none !important; color:white;background-color: blue!important;");
    else typeTab.setAttribute("style", "color:;");

}



function mud__showDict()
{
    var i, j;
    for (i in allDictArray) {
		alert(i) ;    //
    	for ( j in allDictArray[i]) {
		dump(j.checked);
	}
    }
    // alert(allDictArray["en_en"]["OneLook"]);
}



function mud__getDictionaries(mytype, callerType)
{
    
    midmyListbox = document.getElementById("mid_selectdictionaries");
    midmyListbox.setAttribute("onkeypress", "mud__onKeypressDictionaryList(this, event);");

    var midmyListitemh =  document.createElement('listitem');
    var midmyheader    = document.createElement('listcell');
    midmyheader.setAttribute("label", mytype + " : ");
    midmyheader.setAttribute("value", mytype);
    var midmyplaceholder = document.createElement('listcell');
    midmyListitemh.appendChild(midmyheader);
    midmyListitemh.appendChild(midmyplaceholder);
    midmyListitemh.setAttribute("disabled", true);
    midmyListitemh.setAttribute("value", mytype );
    midmyListitemh.setAttribute("style", "background-color:#cFdacF !important;");
    midmyListbox.appendChild(midmyListitemh);

    for (midmydDictionary in allDictArray[mytype]) {

        midmyListitem =  document.createElement('listitem');
        midmyDictRestrictions = document.createElement('listcell');
        midmyDict = document.createElement('listcell');
        if (allDictArray[mytype][midmydDictionary ].middictRestrictions == "" )
	    allDictArray[mytype][midmydDictionary ].middictRestrictions = "-"
	else  midmyDictRestrictions.setAttribute('style', "color : red; min-width: 12em !important;");

        midmyDictRestrictions.setAttribute('label',
        allDictArray[mytype][midmydDictionary].middictRestrictions );
        midmyDictRestrictions.setAttribute("crop", "none"); 
        midmyDict.setAttribute('label', midmydDictionary );
        midmyDict.setAttribute('value', mytype);
           
	midmyListitem.setAttribute('value', mytype);
	// midmyListitem.setAttribute("type", 'checkbox');
	midmyDict.setAttribute( "id", "mid_" + midmydDictionary  );
	midmyDict.setAttribute( "type", "checkbox" );
        midmyDict.setAttribute( "onclick", "mud__onselectDictionary(this);" );

	midmyDict.setAttribute( "style", "white-space : nowrap !important; min-width:14em;" );
        
	// defaults from XUL. 
        if ( allDictArray[mytype][midmydDictionary].middictChecked  == "true" ) {
            //alert("Faszom" + midmydDictionary);
            midmyDict.setAttribute("checked", "true");
        }
        else { midmyDict.setAttribute("checked", "false"); }

	midmyId = allDictArray[mytype][midmydDictionary ].middictId;

        if (midmyprefs.getPrefType("extensions.mid." + midmyId + "_checked")
                      == midmyprefs.PREF_BOOL) {

            if (midmyprefs.getBoolPref("extensions.mid." + midmyId + "_checked") == true ) {
 	        allDictArray[mytype][midmydDictionary ].middictChecked = "true";
	        midmyDict.setAttribute("checked", "true");
	    } else {
	        midmyDict.setAttribute("checked", "false");
 	        allDictArray[mytype][midmydDictionary ].middictChecked = "false";
	    }
        }  // pref exists?
       
        // from facts
        if (window.opener && mud__checkThisType(mytype)) {
            midmyDict.setAttribute("checked", "false");
            allDictArray[mytype][midmydDictionary].middictChecked = "false";
          if (window.opener.document.getElementById('tab' + midmyId)) {
              allDictArray[mytype][midmydDictionary].middictChecked = "false";
              if (!(window.opener.document.getElementById('tab' + midmyId).getAttribute("collapsed") == "true")) {
                  allDictArray[mytype][midmydDictionary ].middictChecked = "true";
                  midmyDict.setAttribute("checked", "true");
              };
          };
        };
        midmyListitem.appendChild(midmyDict);
        midmyListitem.appendChild(midmyDictRestrictions);
        midmyListbox.appendChild(midmyListitem);
        midmyListitem.setAttribute("allowevents", "true");
    } // for

    //midmyListbox.refresh;				  //
    //midmyListbox.ensureElementIsVisible(midmyListitemh);  //

    if (callerType != "init") {
        var x = midmyListbox.getIndexOfItem (midmyListitemh);
        midmyListbox.ensureIndexIsVisible(x + 1);
	midmyListbox.selectItem(midmyListbox.getItemAtIndex(x + 1));
    }
}



function mud__checkThisType(mytype) 
{

    var retvalue = false;
    
    for (var midmydDictionary in allDictArray[mytype]) {
        ctab = window.opener.document.getElementById('tab' 
	           + allDictArray[mytype][midmydDictionary].middictId);  
        if (ctab) {
            if ( ctab.getAttribute("collapsed") != "true"  ) {
             retvalue = true;
            }
        }
    }
    return retvalue;

}



function mud__removeDictionariesFromList(mytype)
{
    var li;
    var midmyListbox = document.getElementById("mid_selectdictionaries");

    midmyListbox.clearSelection();
    var c = midmyListbox.getRowCount();
    midmyListbox.scrollToIndex(0);
    // midmyListbox.ensureIndexIsVisible(0); //?

    for (i = c - 1; (i > - 1); i-- ) {
        li = midmyListbox.getItemAtIndex(i)
        if (li.getAttribute("value") == mytype) {
            while (li.hasChildNodes()) li.removeChild(li.lastChild);
   	    midmyListbox.removeItemAt(midmyListbox.getIndexOfItem(li));
	    li = null;
        }
    }

}




function mud__onselectDictionary(c)
{

    var m               = c; 
    var midmyDictionary = m.getAttribute("label");
    var midmytype       = m.getAttribute("value");
    var checked	        = m.getAttribute("checked");

    if ( checked == "true" ) {
        allDictArray[midmytype][midmyDictionary].middictChecked = "false";
        m.setAttribute("checked", "false") 
    }
    else { 
        allDictArray[midmytype][midmyDictionary].middictChecked = "true";
        m.setAttribute("checked", "true");
    }
    // m.refresh;
   
}



function mud__savePreferences( mytype ) 
{

    middictChecked = false;

    for (midmyDictionary in allDictArray[mytype]) {
        middictId = allDictArray[mytype][midmyDictionary].middictId; 
        if ( allDictArray[mytype][midmyDictionary].middictChecked == "true" ) {
            mylines.push(middictId);
            middictChecked = true;
        }
        else {
             middictChecked = false;
             if ( mylines.join().indexOf(middictId) > -1 )
             mylines.splice( (mylines.join().indexOf(middictId)/37) , 1 );
        }
        if (dictionary == "default")
           midmyprefs.setBoolPref("extensions.mid." + middictId + "_checked", middictChecked   );
    } // for

    // delete mylines; delete allDictArray; delete midmyDictionary;
    
    return true;

}



function  mud__onKeypressDictionaryList(lb, e)
{

    var key = e.which;
	
    if (key == 32) {
        mud__onselectDictionary(lb.selectedItem.getElementsByTagName("listcell").item(0));
    }
	
    event.preventDefault(); 
    event.stopPropagation(); 

    return true;

}



function mud__firstSelTabFocus()
{
    var mytabs = document.getElementById("mid_dicttypetabs"); 
    mytabs.selectedItem.focus();
}



// apokrif functions

function mud__onTypeCheckFocus(tc)
{
    var xpcomInterface = tc.parentNode.boxObject.QueryInterface(
        Components.interfaces.nsIScrollBoxObject);
    xpcomInterface.ensureElementIsVisible(tc);
}



function   mud__dictScroll() {
  alert("OK");
}



function mud__getLocaleString(lsName)
{

    var  myprop = 
             Components.classes["@mozilla.org/intl/stringbundle;1"].
             getService(Components.interfaces.nsIStringBundleService);
    var mystrings = myprop.createBundle("chrome://mid/locale/choose_dict.properties");
    return  mystrings.GetStringFromName(lsName);

}


